<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Grid System</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<!-- Bootsrap's responsive grid system primarily focuses on the patern of C-R-R (container-row-column )

			Container - sets the max width of the layout.
			Row - holds the columns and prevents overflow.
			Column - holds the actual content and its width is determined by the number of columns in a row. There should only be 12 columns in one row.

	 -->
	<div class="container bg-secondary">
	 	<h2>Container</h2>
	 	<div class="row">
	 		<div class="col-6 bg-primary border border-dark">
	 			Div uses 6 columns out of 12.
	 		</div>
	 		<div class="col-6 bg-danger border border-dark">
	 			Div uses 6 columns out of 12.
	 		</div>
	 	</div>
 	</div>
 	<div class="container-fluid bg-dark text-white mt-5">
	 	<h2>Container Fluid</h2>
	 	<div class="row">
	 		<!-- Rows hold columns. If columns are added without being inside a row, they will not be displayed in a row and therefore will not be completely use or take advantage of our grid system.

	 		Rows can only hold 12 columns, if the divs inside exceed 12 columns, the last div will be overflowed to the next row. 

	 		Essentially, what we're doing is setting up a layout wherin we can determine the sizes of each part of our page based on the number of columns.

	 	-->

	 		<div class="col-4 bg-success border border-dark">
	 		Div uses 4 columns out of 12.
	 		</div>
	 		<div class="col-4 bg-primary border border-dark">
	 			Div uses 4 columns out of 12.
	 		</div>
	 		<div class="col-4 bg-warning border border-dark">
	 			Div uses 4 columns out of 12.
	 		</div>
	 		<div class="col-4 bg-secondary border border-dark">
	 			Div uses 4 columns out of 12.
	 		</div>
	 	</div>
 	</div>
 	<div class="container-fluid mt-5">
 		<h1 class="text-center my-5">Page Layout</h1>
 		<div class="row my-5">
 			<div class="col-12 col-md-8 text-center order-2 order-md-1">
 				<h2>What is HTML?</h2>
 				<!-- to use lorem ipsum in sublime for HTML files, type lorem + Tab -->
 				<p>
 					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
 					tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
 					quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
 					consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
 					cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
 					proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
 				</p>
 			</div>
 			<div class="col-12 col-md-4 text-center order-1 order-md-2">
 				<img src="./images/html5.png" class="img-fluid">
 			</div>
 		</div>
 		<div class="row my-5">
 			<div class="col-12 col-md-3 text-center order-2 order-md-1">
 				<h2>What is CSS?</h2>
 				<p>
 					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
 					tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
 					quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
 					consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
 					cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
 					proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
 				</p>
 			</div>
 			<div class="col-12 col-md-6 text-center order-1 order-md-2">
 				<img src="./images/css.png" class="img-fluid">
 			</div>
 			<div class="col-12 col-md-3 text-center order-3 order-md-3">
 				<h2>What are the uses of CSS?</h2>
 				<p>
 					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
 					tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
 					quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
 					consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
 					cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
 					proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
 				</p>
 			</div>
 		</div>
 			<h2>Offsetting Columns</h2>
 			<!-- 
				You can actually move columns to the right by using the offset class.
				Offset class allows us to move columns to the right based on the number of columns.
 			 -->
 			<div class="row my-5">
 				<div class="col-3 offset-3">
 					<!-- 
 					You can resize or scale your picture/img based on the size of the container using img-fluid class. With this you can create/add images which will not overflow from your container.

					The offset column is also counted 
 					 -->
 					<img src="./images/ryan.jpg" class="img-fluid">
 				</div>
 				<div class="col-6">
 					<h3>Who is Ryan Reynolds?</h3>
 					<p>
 						Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
 						tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
 						quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
 						consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse
 						cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non
 						proident, sunt in culpa qui officia deserunt mollit anim id est laborum.
 					</p>
 				</div>
 			</div>
 		
 		<div class="row my-5">
 			<div class="col-2 bg-success border border-dark">
 				<h2>Mini-1</h2>
 			</div>
 			<div class="col-3 bg-primary border-dark">
 				<h2>Mini-2</h2>
 			</div>
 			<div class="col-5 bg-danger border border-dark offset-2">
 				<h2>Mini-3</h2>
 			</div>
 		</div>	
 		<div class="row my-5">
 			<div class="col-3 mx-auto">
 				<img src="https://i.pinimg.com/474x/ec/32/45/ec324549310ed4c5966ffe05f718e66c.jpg" class="img-fluid">
 			</div>
 		</div>
 		<div class="row">
 			<div class="col-4 mx-auto text-center">
 				<h1>Yusuke Urameshi</h1>
 				<h3>Spirit Detective</h3>
 			</div>
 		</div>
 		<!-- Breakpoints -->	
 		<!-- 
				When designating the number of columns a div can occupy the effect, by default, will be from the smallest to largest meaning:

				col-12 - 12 columns from the smallest screen to the largest.
				col-8 - 8 columns from the smallest screen to the largest.

				However, not all layouts should look the same accross all screens.  We have to consider the readability and the sizes of each columns in smaller screens.

				Breakpoints

				Are points/screens where in we can set a different layout or number of columns to a div.

				<div class="col-12 col-md-4"> 
					= this div is 12 columns from the smallest screen. 4 columns from the medium screen to the largest.
				</div>

				Columns can be sized with breakpoints starting from the smallest screen:

				col-* - from the smallest screen
				col-sm-* - breakpoint from from small screen or about 576px screen width.
				col-md-* - breakpoint from from medium screen or about 768px screen width.
				col-lg-* - breakpoint from from large screen or about 992px screen width.
				col-xl-* - breakpoint from from largest screen or about 1200px screen width.

 		 -->	
 		 <div class="row my-5">
 		 	<div class="col-12 col-md-6 bg-primary border border-dark p-5">
 		 		12 columns in small screen
 		 		6 columns from medium screen to the largest
 		 	</div>
 		 	<div class="col-12 col-md-6 bg-danger border border-dark p-5">
 		 		12 columns in small screen
 		 		6 columns from medium screen to xl
 		 	</div>
 		 </div>
 		 <div class="row my-5">
 		 	<div class="col-6 col-md-3 col-lg-6 bg-success border border-dark p-5">
 		 		6 cols in small
 		 		3 cols in tablet
 		 		6 cols in lg to xl
 		 	</div>
 		 	<div class="col-3 col-md-6 col-lg-3 bg-info border border-dark p-5">
 		 		3 cols in small
 		 		6 cols in tablet
 		 		3 cols in lg to xl
 		 	</div>
 		 </div>
 		 <div>
 		 	<h3>Mini-Activity</h3>
 		 	<div class="row my-5">
 		 		<div class="col-6 col-sm-6 col-md-3 border border-dark p-5 bg-warning">
 		 			6 Cols in sm, 3 cols in md to xl
 		 		</div>
 		 		<div class="col-6 col-sm-6 col-md-3 border border-dark p-5 bg-warning">
 		 			6 Cols in sm, 3 cols in md to xl
 		 		</div>
 		 		<div class="col-6 col-sm-6 col-md-3 border border-dark p-5 bg-warning">
 		 			6 Cols in sm, 3 cols in md to xl
 		 		</div>
 		 		<div class="col-6 col-sm-6 col-md-3 border border-dark p-5 bg-warning">
 		 			6 Cols in sm, 3 cols in md to xl
 		 		</div>
 		 	</div>
 		 </div>
 		 <!-- Order -->
 		 <!-- You can actually change the order of divs in a row per screen or breakpoint -->
 		 <div class="row my-5">
 		 	<div class="col-12 col-md-4 bg-warning border border-dark p-3 order-3 order-md-3">
 		 		LeBron James
 		 	</div>
 		 	<div class="col-12 col-md-4 bg-dark text-white p-3 order-1 order-md-2">
 		 		Kevin Durant
 		 	</div>
 		 	<div class="col-12 col-md-4 bg-primary border border-dark p-3 order-2 order-md-1">
 		 		Stephen Curry
 		 	</div>
 		 	
 		 </div>
 	</div>


	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.min.js" integrity="sha384-VHvPCCyXqtD5DqJeNxl2dtTyhF78xXNXdkwX1CZeRusQfRKp+tA7hAShOK/B/fQ2" crossorigin="anonymous"></script>
</body>
</html>